/* 
 Copyright 2005,2006 Foxmarks Inc.
 
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 	
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 
 foxmarks-conflicts.js: provides setup routines specific for each conflict
 dialog, as well as common event handlers for user input.
  
 */
 
function ConflictSelectLocal()
{
	window.arguments[0].selection = "local";
	window.arguments[0].canceled = false;
	window.arguments[0].source = window.arguments[1].local;
	window.arguments[0].dest = window.arguments[1].remote;
	window.close();
}

function ConflictSelectRemote()
{
	window.arguments[0].selection = "remote";
	window.arguments[0].canceled = false;
	window.arguments[0].source = window.arguments[1].remote;
	window.arguments[0].dest = window.arguments[1].local;
	window.close();
}

function ConflictCancel()
{
	dump("FolderConflictCancel");
	window.arguments[0].selection = "";
	window.arguments[0].canceled = true;
	return true;
}


function OnFolderConflictLoad()
{
	document.getElementById("localname").value = window.arguments[1].localname;
	document.getElementById("localdesc").value = window.arguments[1].localdesc;
	document.getElementById("remotename").value = window.arguments[1].remotename;
	document.getElementById("remotedesc").value = window.arguments[1].remotedesc;
}

function OnParentConflictLoad()
{
	document.getElementById("itemname").value = window.arguments[1].itemname;
	document.getElementById("localname").value = window.arguments[1].localname;
	document.getElementById("localdesc").value = window.arguments[1].localdesc;
	document.getElementById("remotename").value = window.arguments[1].remotename;
	document.getElementById("remotedesc").value = window.arguments[1].remotedesc;
}

function OnOrderConflictLoad()
{
	document.getElementById("itemname").value = window.arguments[1].itemname;
	var localtree = document.getElementById("localtree");
	localtree.database.AddDataSource(window.arguments[1].localdatasource);
	localtree.ref = window.arguments[1].localroot;
	var remotetree = document.getElementById("remotetree");
	remotetree.database.AddDataSource(window.arguments[1].remotedatasource);
	remotetree.ref = window.arguments[1].remoteroot;
}

function OnBookmarkConflictLoad()
{
	document.getElementById("localname").value = window.arguments[1].localname;
	document.getElementById("localurl").value = window.arguments[1].localurl;
	document.getElementById("localkeyword").value = window.arguments[1].localkeyword;
	document.getElementById("localdesc").value = window.arguments[1].localdesc;
	document.getElementById("localwebpanel").checked = window.arguments[1].localwebpanel;
	document.getElementById("remotename").value = window.arguments[1].remotename;
	document.getElementById("remoteurl").value = window.arguments[1].remoteurl;
	document.getElementById("remotekeyword").value = window.arguments[1].remotekeyword;
	document.getElementById("remotedesc").value = window.arguments[1].remotedesc;
	document.getElementById("remotewebpanel").checked = window.arguments[1].remotewebpanel;
}

function OnSeparatorConflictLoad()
{
  OnOrderConflictLoad();
}
