/* 
 Copyright 2005,2006 Foxmarks Inc.
 
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 	
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 
 foxmarks-overlay.js: implement the foxmarks overlay, which provides hooks
 for the few functions that exist outside of the setup dialog, e.g., launching
 the setup dialog, performing sync on load/unload, etc. 
 */
 
// function stolen from browser.js
function toOpenWindowByType(inType, uri, features)
{
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow(inType);
 
   if (topWindow)
     topWindow.focus();
   else if (features)
     window.open(uri, "_blank", features);
   else
     window.open(uri, "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
}

function OpenFoxmarksSettingsDialog()
{
	toOpenWindowByType("foxmarks:settings", "chrome://foxmarks/content/foxmarks-dialog.xul", "chrome");
}

var gFoxmarksObserver = {

  onFoxmarksProgress: function(status, msg, complete)
  {
    window.XULBrowserWindow.setJSStatus("Foxmarks: " + msg);
    
    if (complete) {
      setTimeout(gFoxmarksObserver.clearStatus, status != 0 ? 5000 : 1000);
    }
  },
  
  clearStatus: function()
  {
    window.XULBrowserWindow.setJSStatus("");
  }
}
	

function Synch()
{
  var foxmarks = Components.classes["@foxcloud.com/extensions/foxmarks;1"]
      .getService(Components.interfaces.nsIFoxmarksService);
      
  foxmarks.synchronize(gFoxmarksObserver);
}

function FoxmarksBrowserLoad()
{
  if (!gSettings.wizardSuppress && !gSettings.HaveSynched)
    toOpenWindowByType("foxmarks:setup", "chrome://foxmarks/content/foxmarks-setup.xul", "chrome,centerscreen");
    
  return;
}

window.addEventListener("load", FoxmarksBrowserLoad, false);
