/*
 Copyright 2005,2006 Foxmarks Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.

 foxmarks-update.js: implements interface to Firefox extensions manager for
 handling updates of the extension.

 */


var em;

function ForceUpdate()
{
    // find a window to use as a parent for open
    var topwin = Components.classes['@mozilla.org/appshell/window-mediator;1'].
        getService(Components.interfaces.nsIWindowMediator).
        getMostRecentWindow(null);

    // first, open the extension manager window
    em = topwin.
        open("chrome://mozapps/content/extensions/extensions.xul?type=extensions",
        "_blank", "chrome,dialog=no,resizable");
    em.addEventListener("pageshow", ExtensionManagerShow, false);

    function ExtensionManagerShow(arg) {
    const id = "urn:mozilla:item:foxmarks@kei.com";

        // find our entry in the extension manager's view
        with (em) {
            var children = gExtensionsView.children;

            while (children.length > 0) {
                var item = children.shift()

                if (item.id == id) {       // found it, install it
                    gExtensionsView.selectedItem = item;
                    var updateitem = gExtensionManager.
                        getItemForID("foxmarks@kei.com");
                    var listener = new FoxmarksUpdateCheckListener();
                    gExtensionManager.update([updateitem], 1, false, listener);
                    break;
                }
            }
        }
    }
}

function FoxmarksUpdateCheckListener() {
}

FoxmarksUpdateCheckListener.prototype = {
    onUpdateStarted: function() {
        LogWrite("onUpdateStarted");
    },

    onUpdateEnded: function() {
        LogWrite("onUpdatedEnded");
    },

    onAddonUpdateStarted: function(addon) {
        LogWrite("onAddonUpdateStarted");
    },

    onAddonUpdateEnded: function(addon, status) {
        LogWrite("onAddonUpdatedEnded, status = " + status);

        const nsIAUCL = Components.interfaces.nsIAddonUpdateCheckListener;
        switch (status) {
            case nsIAUCL.STATUS_UPDATE:
              em.gExtensionManager.addDownloads([addon], 1, true);
              break;
            case nsIAUCL.STATUS_FAILURE:
              break;
            case nsIAUCL.STATUS_DISABLED:
              break;
        }
    },

    /**
    * See nsISupports.idl
    */
    QueryInterface: function(iid) {
        if (!iid.equals(Components.interfaces.nsIAddonUpdateCheckListener) &&
            !iid.equals(Components.interfaces.nsISupports))
                throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    }
}

function UpdateNag()
{
    var sb = Bundle().GetStringFromName;

    if (Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
      getService(Components.interfaces.nsIPromptService).
      confirm(null, sb("appname.long"), sb("msg.upgradeAvailable"))) {
      ForceUpdate();
    }
}
